/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-07-31 17:31:34.
 * *************************************************
 */

package cn.com.qmth.examcloud.app.service;

import cn.com.qmth.examcloud.app.model.Result;

/**
 * 网考业务服务接口
 *
 * @author: fengdesheng
 * @since: 2018/7/31
 */
public interface NetExamService {

    Result getCurrentTime(String key, String token) throws Exception;

    Result getOfflineExamCourseList(String key, String token) throws Exception;

    Result startOfflineExamRecord(String key, String token, String examStudentId) throws Exception;

    Result uploadPaperAnswer(String key, String token, String examRecordId, byte[] fileBytes, String fileName, String md5) throws Exception;

    Result getPracticeExamCourseList(String key, String token, String examId) throws Exception;

    Result getExamRecordHeartbeat(String key, String token, String examRecordId) throws Exception;

    Result startPracticeExamRecord(String key, String token, String examStudentId) throws Exception;

    Result getExamRecordPaperStructList(String key, String token, String examRecordId) throws Exception;

    Result getExamRecordPaperQuestionList(String key, String token, String examRecordId) throws Exception;

    Result getExamRecordPaperQuestionDetail(String key, String token, String questionId) throws Exception;

    Result updateExamRecordPaperQuestionAnswer(String key, String token, String examQuestionId, String studentAnswer) throws Exception;

    Result submitPracticeExamRecord(String key, String token, String examRecordId) throws Exception;

    Result checkOnlineExamRecord(String key, String token) throws Exception;

    @Deprecated
    Result getExamRecordPracticeTotalInfo(String key, String token, String examStudentId) throws Exception;

    Result getExamRecordPracticeHistoryList(String key, String token, String examStudentId) throws Exception;

    Result getExamRecordTotalInfo(String key, String token, String examRecordId) throws Exception;

    Result getExamRecordQuestionDetailList(String key, String token, String examRecordId) throws Exception;

    Result getExamRecordQuestionAudioPlayTimes(String key, String token, String questionId) throws Exception;

    Result updateExamRecordQuestionAudioPlayTimes(String key, String token, String questionId, String mediaName) throws Exception;

}