/*
 * *************************************************
 * Copyright (c) 2018 QMTH. All Rights Reserved.
 * Created by Deason on 2018-07-31 17:40:42.
 * *************************************************
 */

package cn.com.qmth.examcloud.app.service;

import cn.com.qmth.examcloud.app.model.LoginInfo;
import cn.com.qmth.examcloud.app.model.Result;
import cn.com.qmth.examcloud.app.model.User;

/**
 * 认证中心业务服务接口
 *
 * @author: fengdesheng
 * @since: 2018/7/31
 */
public interface UserAuthService {

    Result<User> login(LoginInfo loginInfo) throws Exception;

    Result logout(String key, String token) throws Exception;

    Result getUserInfo(String key, String token) throws Exception;

    Result updatePassword(String key, String token, Long userId, String password) throws Exception;

    Result userBindingPhone(String key, String token, Long userId, String phone, String code);

    void cacheLoginInfo(LoginInfo loginInfo, User userInfo);

    void cacheLoginInfo(LoginInfo loginInfo, String key);

    LoginInfo getLoginInfo(String key);

    int getSessionTimeout();

    void initRequestTrace();

}